
Imports System.Drawing

Imports MindFusion.Diagramming
Imports MindFusion.Diagramming.Layout


Partial Public Class _Default
	Inherits System.Web.UI.Page

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

		If (Not IsPostBack) Then

			Dim diagram As Diagram = diagramView.Diagram
			diagram.DefaultShape = Shapes.Ellipse
			diagram.ShapeNodeStyle.Brush = New MindFusion.Drawing.SolidBrush(Color.DarkViolet)

			Dim root As ShapeNode = diagram.Factory.CreateShapeNode(0, 0, 10, 10)
			root.Tag = 0
			CreateTree(diagram, root, 0)

			Dim layout As New TreeLayout()
			layout.Type = TreeLayoutType.Radial
			layout.LevelDistance = 20
			layout.Arrange(diagram)

		End If

	End Sub

	Private Sub CreateTree(diagram As Diagram, parent As ShapeNode, level As Integer)

		If (level >= 2 + Random.Next(2)) Then
			Return
		End If

		Dim count As Integer = random.Next(3) + 3
		Dim i As Integer
		For i = 0 To count - 1

			Dim [next] As ShapeNode = diagram.Factory.CreateShapeNode(0, 0, 10, 10)
			[next].Tag = level
			diagram.Factory.CreateDiagramLink(parent, [next])
			CreateTree(diagram, [next], level + 1)

		Next i

	End Sub

	Protected Sub btnExportPdf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExportPdf.Click
		Dim pdf As MindFusion.Diagramming.Export.PdfExporter = _
		 New MindFusion.Diagramming.Export.PdfExporter()

		Dim path As String = Server.MapPath("~\PDF\") + Session.SessionID + ".pdf"
		pdf.Export(diagramView.Diagram, path)
		pdfURL.Value = "PDF/" + Session.SessionID + ".pdf"
	End Sub


	Private random As Random = New Random(DateTime.Now.Millisecond)
End Class